unit terminal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CPortCtl, CPort, Buttons, Spin, ExtCtrls, Grids,
  ValEdit, ComCtrls;

 type
   TNewNone = record
     NodeID     : integer;
     SensorID   : integer;
     MessageType: integer;
     ACK        : integer;
     SubType    : integer;
     Payload    : string[255];
   end;

type

  CBuf = array[0..2048] of Byte;
  PBuf = ^CBuf;

  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ComPort1: TComPort;
    ComComboBox1: TComComboBox;
    ComComboBox2: TComComboBox;
    Button2: TButton;
    BitBtn1: TBitBtn;
    GroupBox2: TGroupBox;
    LabeledEdit1: TLabeledEdit;
    nID: TSpinEdit;
    sID: TSpinEdit;
    CheckBox1: TCheckBox;
    mType: TComboBox;
    sType: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Label5: TLabel;
    Label6: TLabel;
    ValueListEditor1: TValueListEditor;
    TreeView1: TTreeView;
    ErrorMemo: TMemo;
    Button3: TButton;
    Button4: TButton;
    CheckBox2: TCheckBox;
    Timer1: TTimer;
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure ComComboBox1Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure mTypeChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure GeneratePacket;
    procedure sIDChange(Sender: TObject);
    procedure sTypeChange(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure nIDChange(Sender: TObject);
    procedure ValueListEditor1DblClick(Sender: TObject);
    procedure ParsePacket(sPacket: String);
    procedure ComComboBox2Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  RxBuf: CBuf;
  sTemp:string;
  sNewData: TNewNone;
  SendNewID:string;

implementation

{$R *.dfm}

function GetMessageType(iMessageType:dword;iSubType:dword):string;
begin
  case iMessageType of
  0:
    begin
      case iSubType of
      0:result:=('S_DOOR');
      1:result:=('S_MOTION');
      2:result:=('S_SMOKE');
      3:result:=('S_LIGHT');
      4:result:=('S_DIMMER');
      5:result:=('S_COVER');
      6:result:=('S_TEMP');
      7:result:=('S_HUM');
      8:result:=('S_BARO');
      9:result:=('S_WIND');
      10:result:=('S_RAIN');
      11:result:=('S_UV');
      12:result:=('S_WEIGHT');
      13:result:=('S_POWER');
      14:result:=('S_HEATER');
      15:result:=('S_DISTANCE');
      16:result:=('S_LIGHT_LEVEL');
      17:result:=('S_ARDUINO_NODE');
      18:result:=('S_ARDUINO_RELAY');
      19:result:=('S_LOCK');
      20:result:=('S_IR');
      21:result:=('S_WATER');
      22:result:=('S_AIR_QUALITY');
      23:result:=('S_CUSTOM');
      24:result:=('S_DUST');
      25:result:=('S_SCENE_CONTROLLER');
      else result:='not supported';
      end;
    end;
  1..2:
    begin
      case iSubType of
      0:result:=('V_TEMP');
      1:result:=('V_HUM');
      2:result:=('V_LIGHT');
      3:result:=('V_DIMMER');
      4:result:=('V_PRESSURE');
      5:result:=('V_FORECAST');
      6:result:=('V_RAIN');
      7:result:=('V_RAINRATE');
      8:result:=('V_WIND');
      9:result:=('V_GUST');
      10:result:=('V_DIRECTION');
      11:result:=('V_UV');
      12:result:=('V_WEIGHT');
      13:result:=('V_DISTANCE');
      14:result:=('V_IMPEDANCE');
      15:result:=('V_ARMED');
      16:result:=('V_TRIPPED');
      17:result:=('V_WATT');
      18:result:=('V_KWH');
      19:result:=('V_SCENE_ON');
      20:result:=('V_SCENE_OFF');
      21:result:=('V_HEATER');
      22:result:=('V_HEATER_SW');
      23:result:=('V_LIGHT_LEVEL');
      24:result:=('V_VAR1');
      25:result:=('V_VAR2');
      26:result:=('V_VAR3');
      27:result:=('V_VAR4');
      28:result:=('V_VAR5');
      29:result:=('V_UP');
      30:result:=('V_DOWN');
      31:result:=('V_STOP');
      32:result:=('V_IR_SEND');
      33:result:=('V_IR_RECEIVE');
      34:result:=('V_FLOW');
      35:result:=('V_VOLUME');
      36:result:=('V_LOCK_STATUS');
      37:result:=('V_DUST_LEVEL');
      38:result:=('V_VOLTAGE');
      39:result:=('V_CURRENT');
      else result:='not supported';
      end;
    end;
  3:
    begin
      case iSubType of
      0:result:=('I_BATTERY_LEVEL');
      1:result:=('I_TIME');
      2:result:=('I_VERSION');
      3:result:=('I_ID_REQUEST');
      4:result:=('I_ID_RESPONSE');
      5:result:=('I_INCLUSION_MODE');
      6:result:=('I_CONFIG');
      7:result:=('I_FIND_PARENT');
      8:result:=('I_FIND_PARENT_RESPONSE');
      9:result:=('I_LOG_MESSAGE');
      10:result:=('I_CHILDREN');
      11:result:=('I_SKETCH_NAME');
      12:result:=('I_SKETCH_VERSION');
      13:result:=('I_REBOOT');
      14:result:=('I_GATEWAY_READY');
      else result:='not supported';
      end;
    end;
  4:
    begin
      case iSubType of
      0:result:='OTA';
      else result:='not supported';
      end;
    end;
  else result:='not supported';
  end;
end;

function GivePosition(sChar:char;sString:string;iCharCount:dword):integer;
var iTemp:integer;
    iCount:dword;
begin
iCount:=1;
for iTemp:=1 to length(sString) do
  begin
   if sString[iTemp]=sChar then
    begin
    if iCharCount = iCount then break
    else inc(iCount);
    end;
  end;
if iTemp=length(sString) then Result:=-1 else Result:=iTemp;
end;

// Find root node , compare complete node name
function FindRootNode(ACaption: String; ATreeView: TTreeView): TTreeNode;
var LCount: Integer;
begin
  result := nil;
  LCount := 0;
  while (LCount < ATreeView.Items.Count) and (result = nil) do
  begin
    if (ATreeView.Items.Item[LCount].Text = ACaption) and (ATreeView.Items.Item[LCount].Parent = nil) then
      result := ATreeView.Items.Item[LCount];
    inc(LCount);
  end;
end;

// Find root node ID .. node name is example : 25 Binary Switch
// compare only first number defined node ID
function FindRootNodeID(NodeID: String; ATreeView: TTreeView): TTreeNode;
var LCount: Integer;
    sTemp : string[255];
    iTemp : word;
begin
  result := nil;
  LCount := 0;
  while (LCount < ATreeView.Items.Count) and (result = nil) do
  begin
    if length(ATreeView.Items.Item[LCount].Text) < 255 then
      Begin
        iTemp:=Pos(' ',ATreeView.Items.Item[LCount].Text);
        sTemp := copy(ATreeView.Items.Item[LCount].Text,0,iTemp-1);
        if (sTemp = NodeID) and (ATreeView.Items.Item[LCount].Parent = nil) then result := ATreeView.Items.Item[LCount];
        inc(LCount);
      end;
  end;
end;
// Searching in child , sub node number only .. not all text..
function FindChildNodeID(NodeID: String; ATreeView: TTreeNode): TTreeNode;
var
    sTemp : string[255];
    iTemp : word;
    nTemp : TTreeNode;
begin
nTemp:=ATreeView.getFirstChild;
while nTemp <> nil do
  begin
    iTemp:=Pos(' ',nTemp.Text);
    sTemp := copy(nTemp.Text,0,iTemp-1);
    if (sTemp = NodeID) then break;
    nTemp:=ATreeView.GetNextChild(nTemp);
  end;
result:=nTemp;
end;

procedure TForm1.GeneratePacket;
begin
Label6.Caption:=inttostr(nID.Value)+';';
Label6.Caption:=Label6.Caption+inttostr(sID.Value)+';';
Label6.Caption:=Label6.Caption+inttostr(mType.ItemIndex)+';';
if checkbox1.Checked then Label6.Caption:=Label6.Caption+'1;' else Label6.Caption:=Label6.Caption+'0;';
Label6.Caption:=Label6.Caption+inttostr(sType.ItemIndex)+';';
Label6.Caption:=Label6.Caption+LabeledEdit1.Text;
end;

procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
var   iTemp:integer;
begin
ComPort1.Read(RxBuf,Count);
for iTemp:=0 to Count-1 do
  begin
  if (RxBuf[iTemp] = $0A) then
    begin
    ValueListEditor1.InsertRow(timetostr(now)+' '+datetostr(now),sTemp,true);
    ParsePacket(sTemp);
    sTemp:='';
    if ValueListeditor1.Strings.Count > 1000 then ValueListEditor1.Strings.Clear;
    end
  else sTemp:=sTemp+Chr(RxBuf[iTemp]);
  end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
ComPort1.Connected:=false;
TreeView1.SaveToFile(ExtractFilePath(Application.ExeName)+'node.dat');
//TreeView1.SaveToFile();
end;

procedure TForm1.Button2Click(Sender: TObject);
var iTick,iTickOld:TDateTime;
begin
if ComPort1.Connected then
  begin
  ComPort1.FlowControl.ControlDTR:=dtrEnable;
  iTickOld:=GetTime;
  iTick:=iTickOld;
  while (iTickOld+1000<(iTick))do begin iTick:=GetTime;end;
  ComPort1.FlowControl.ControlDTR:=dtrDisable;
  end;
end;

procedure TForm1.ComComboBox1Change(Sender: TObject);
begin
if ComPort1.Connected then Begin ComPort1.Connected:=false;BitBtn1.Caption:='Disconnect';BitBtn1.Font.Color:=clBlue;end;
ComPort1.Port:=ComComboBox1.Text;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
sTemp:='';
if (BitBtn1.Caption='Connect') then
  Begin
    ComPort1.Connected:=true;
    ComPort1.FlowControl.ControlDTR:=dtrDisable;
    BitBtn1.Caption:='Disconnect';
    BitBtn1.Font.Color :=clGreen;
  end
  else
  Begin
    BitBtn1.Caption:='Connect';
    ComPort1.Connected:=false;
    BitBtn1.Font.Color:=clBlue;
  end;
end;

procedure TForm1.mTypeChange(Sender: TObject);
begin
  case mType.ItemIndex of
  0:
    begin
      sType.Items.Clear;
      sType.Text:='S_DOOR';
      sType.Items.Append('S_DOOR');
      sType.Items.Append('S_MOTION');
      sType.Items.Append('S_SMOKE');
      sType.Items.Append('S_LIGHT');
      sType.Items.Append('S_DIMMER');
      sType.Items.Append('S_COVER');
      sType.Items.Append('S_TEMP');
      sType.Items.Append('S_HUM');
      sType.Items.Append('S_BARO');
      sType.Items.Append('S_WIND');
      sType.Items.Append('S_RAIN');
      sType.Items.Append('S_UV');
      sType.Items.Append('S_WEIGHT');
      sType.Items.Append('S_POWER');
      sType.Items.Append('S_HEATER');
      sType.Items.Append('S_DISTANCE');
      sType.Items.Append('S_LIGHT_LEVEL');
      sType.Items.Append('S_ARDUINO_NODE');
      sType.Items.Append('S_ARDUINO_RELAY');
      sType.Items.Append('S_LOCK');
      sType.Items.Append('S_IR');
      sType.Items.Append('S_WATER');
      sType.Items.Append('S_AIR_QUALITY');
      sType.Items.Append('S_CUSTOM');
      sType.Items.Append('S_DUST');
      sType.Items.Append('S_SCENE_CONTROLLER');
      sType.ItemIndex:=0;
    end;
  1..2:
    begin
      sType.Items.Clear;
      sType.Text:='V_TEMP';
      sType.Items.Append('V_TEMP');
      sType.Items.Append('V_HUM');
      sType.Items.Append('V_LIGHT');
      sType.Items.Append('V_DIMMER');
      sType.Items.Append('V_PRESSURE');
      sType.Items.Append('V_FORECAST');
      sType.Items.Append('V_RAIN');
      sType.Items.Append('V_RAINRATE');
      sType.Items.Append('V_WIND');
      sType.Items.Append('V_GUST');
      sType.Items.Append('V_DIRECTION');
      sType.Items.Append('V_UV');
      sType.Items.Append('V_WEIGHT');
      sType.Items.Append('V_DISTANCE');
      sType.Items.Append('V_IMPEDANCE');
      sType.Items.Append('V_ARMED');
      sType.Items.Append('V_TRIPPED');
      sType.Items.Append('V_WATT');
      sType.Items.Append('V_KWH');
      sType.Items.Append('V_SCENE_ON');
      sType.Items.Append('V_SCENE_OFF');
      sType.Items.Append('V_HEATER');
      sType.Items.Append('V_HEATER_SW');
      sType.Items.Append('V_LIGHT_LEVEL');
      sType.Items.Append('V_VAR1');
      sType.Items.Append('V_VAR2');
      sType.Items.Append('V_VAR3');
      sType.Items.Append('V_VAR4');
      sType.Items.Append('V_VAR5');
      sType.Items.Append('V_UP');
      sType.Items.Append('V_DOWN');
      sType.Items.Append('V_STOP');
      sType.Items.Append('V_IR_SEND');
      sType.Items.Append('V_IR_RECEIVE');
      sType.Items.Append('V_FLOW');
      sType.Items.Append('V_VOLUME');
      sType.Items.Append('V_LOCK_STATUS');
      sType.Items.Append('V_DUST_LEVEL');
      sType.Items.Append('V_VOLTAGE');
      sType.Items.Append('V_CURRENT');
      sType.ItemIndex:=0;
    end;
  3:
    begin
      sType.Items.Clear;
      sType.Text:='I_BATTERY_LEVEL';
      sType.Items.Append('I_BATTERY_LEVEL');
      sType.Items.Append('I_TIME');
      sType.Items.Append('I_VERSION');
      sType.Items.Append('I_ID_REQUEST');
      sType.Items.Append('I_ID_RESPONSE');
      sType.Items.Append('I_INCLUSION_MODE');
      sType.Items.Append('I_CONFIG');
      sType.Items.Append('I_FIND_PARENT');
      sType.Items.Append('I_FIND_PARENT_RESPONSE');
      sType.Items.Append('I_LOG_MESSAGE');
      sType.Items.Append('I_CHILDREN');
      sType.Items.Append('I_SKETCH_NAME');
      sType.Items.Append('I_SKETCH_VERSION');
      sType.Items.Append('I_REBOOT');
      sType.Items.Append('I_GATEWAY_READY');
      sType.ItemIndex:=0;
    end;
  4:
    begin
      sType.Items.Clear;
      sType.Text:='OTA';
      sType.Items.Append('OTA');
      sType.ItemIndex:=0;
    end;
  else
   begin
      sType.Items.Clear;
      sType.Text:='unsuported';
      sType.Items.Append('unsuported');
      sType.ItemIndex:=0;
   end;
  end;
GeneratePacket;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
      sType.Items.Clear;
      sType.Text:='S_DOOR';
      sType.Items.Append('S_DOOR');
      sType.Items.Append('S_MOTION');
      sType.Items.Append('S_SMOKE');
      sType.Items.Append('S_LIGHT');
      sType.Items.Append('S_DIMMER');
      sType.Items.Append('S_COVER');
      sType.Items.Append('S_TEMP');
      sType.Items.Append('S_HUM');
      sType.Items.Append('S_BARO');
      sType.Items.Append('S_WIND');
      sType.Items.Append('S_RAIN');
      sType.Items.Append('S_UV');
      sType.Items.Append('S_WEIGHT');
      sType.Items.Append('S_POWER');
      sType.Items.Append('S_HEATER');
      sType.Items.Append('S_DISTANCE');
      sType.Items.Append('S_LIGHT_LEVEL');
      sType.Items.Append('S_ARDUINO_NODE');
      sType.Items.Append('S_ARDUINO_RELAY');
      sType.Items.Append('S_LOCK');
      sType.Items.Append('S_IR');
      sType.Items.Append('S_WATER');
      sType.Items.Append('S_AIR_QUALITY');
      sType.Items.Append('S_CUSTOM');
      sType.Items.Append('S_DUST');
      sType.Items.Append('S_SCENE_CONTROLLER');
      sType.ItemIndex:=0;
if FileExists(ExtractFilePath(Application.ExeName)+'node.dat') then TreeView1.LoadFromFile(ExtractFilePath(Application.ExeName)+'node.dat');
end;

procedure TForm1.sIDChange(Sender: TObject);
begin
if length(sID.Text)>0 then begin if (sID.Value > sID.MinValue-1) and (sID.Value < sID.MaxValue+1) then GeneratePacket;end;
end;

procedure TForm1.nIDChange(Sender: TObject);
begin
if length(nID.Text)>0 then begin if (nID.Value > nID.MinValue-1) and (nID.Value < nID.MaxValue+1) then GeneratePacket;end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
GeneratePacket;
end;

procedure TForm1.sTypeChange(Sender: TObject);
begin
GeneratePacket;
end;

procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
if length(LabeledEdit1.text) > 0 then GeneratePacket else LabeledEdit1.Text:='0';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//GeneratePacket;
ComPort1.WriteStr(Label6.Caption+char($0A));
end;

procedure TForm1.ValueListEditor1DblClick(Sender: TObject);
begin
ValueListEditor1.Strings.Clear;
end;

procedure TForm1.ComComboBox2Change(Sender: TObject);
begin
      with ComPort1 do
      begin
        BeginUpdate;
//        Port := cbbComPortPort.Items[cbbComPortPort.ItemIndex];
        BaudRate := TBaudRate(COmComboBOx2.ItemIndex);
//        DataBits := TDataBits(cbbComPortDataBits.ItemIndex);
//        StopBits := TStopBits(cbbComPortStopBits.ItemIndex);
//        Parity.Bits := TParityBits(cbbComPortParity.ItemIndex);
//        FlowControl.FlowControl := TFlowControl(cbbComPortFlowControl.ItemIndex);
        EndUpdate;
      end;
end;

procedure TForm1.ParsePacket(sPacket: String);
var sParse:TStringList;
    iPos:integer;
    node,subnode,sensornode:TTreeNode;
    newID:boolean;
    FreeID:integer;
begin
newID:=false;
sParse:=TStringList.Create;
if length(sPacket) > 255 then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error input packet! > 255'); exit;end;
ExtractStrings([';'],[' '],PChar(sPacket),sParse);
if (sParse.Count<5) then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error Packet : parse argument < 5'); exit;end
  else
    Begin
      if (TryStrToInt(sParse.Strings[0],sNewData.NodeID)=false) then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error Node ID : not int'); exit;end;
      if (TryStrToInt(sParse.Strings[1],sNewData.SensorID)=false) then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error Sensor ID : not int'); exit;end;
      if (TryStrToInt(sParse.Strings[2],sNewData.MessageType)=false) then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error Message Type : not int'); exit;end;
      if (TryStrToInt(sParse.Strings[3],sNewData.ACK)=false) then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error ACK : not int'); exit;end;
      if (TryStrToInt(sParse.Strings[4],sNewData.SubType)=false) then begin ErrorMemo.Lines.Append(datetimetostr(now)+' Error Sub Type : not int'); exit;end;
      if (sParse.Count=5) then sNewData.Payload:=' ';
      if (sParse.Count=6) then sNewData.Payload:=sParse.Strings[5];
      if (sParse.Count>6) then
        //reconstruct Payload ... ';'
          Begin
           iPos:=GivePosition(';',sPacket,5);
           if iPos>-1 then sNewData.Payload:=Copy(sPacket,iPos+1,length(sPacket)-iPos+1);
          end;
      if sNewData.NodeID > 0 then
        Begin
          if sNewData.NodeID = 255 then begin newID:=true; {sensor need new ID ???}end
          else
            Begin
             node := FindRootNodeID(inttostr(sNewData.NodeID),TreeView1);
             if node = nil then begin node:=TreeView1.Items.Add(nil,inttostr(sNewData.NodeID)+' undefined');end;
             if sNewData.SensorID = 255 then
              begin
                subnode:= FindChildNodeID(inttostr(sNewData.SubType),node);
                if subnode = nil then
                  begin
                    {subnode:=}TreeView1.Items.AddChild(node,inttostr(sNewData.SubType)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')');
                    if (sNewData.MessageType=3) and (sNewData.SubType=11) then node.Text :=inttostr(sNewData.NodeID)+' ('+sNewData.Payload+')';
                  end
                else
                  Begin
                    if sNewData.MessageType =0 then subnode.Text:= inttostr(sNewData.SubType)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')';
                      if sNewData.MessageType =3 then subnode.Text:=inttostr(sNewData.SubType)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')';
//                      if sNewData.MessageType =1 then
  //                      begin
    //                      sensornode:= FindChildNodeID(inttostr(sNewData.SensorID),subnode);
      //                    if sensornode = nil then {sensornode:=}TreeView1.Items.AddChild(subnode,inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')')
        //                  else sensornode.Text:= inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')';
          //              end;
                  End;
              end
             else
              begin
                subnode:= FindChildNodeID(inttostr(sNewData.SensorID),node);
                if subnode = nil then
                  begin
                    if sNewData.MessageType =0 then {subnode:=}TreeView1.Items.AddChild(node,inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')');
                    if sNewData.MessageType =3 then {subnode:=}TreeView1.Items.AddChild(node,inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')');
                    if sNewData.MessageType =1 then
                      begin
                        subnode:=TreeView1.Items.AddChild(node,inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')');
                        {sensornode:=}TreeView1.Items.AddChild(subnode,inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')');
                      end;
                  end
                else
                  begin
                    if sNewData.MessageType =0 then subnode.Text:= inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')';
                      if sNewData.MessageType =3 then subnode.Text:=inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')';
                      if sNewData.MessageType =1 then
                        begin
                          sensornode:= FindChildNodeID(inttostr(sNewData.SensorID),subnode);
                          if sensornode = nil then {sensornode:=}TreeView1.Items.AddChild(subnode,inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')')
                          else sensornode.Text:= inttostr(sNewData.SensorID)+' {'+GetMessageType(sNewData.MessageType,sNewData.SubType)+'} ('+sNewData.Payload+')';
                        end;
                  end;
              end;
            End;
        // if gateway send or received .. here..
        end;
    end;
sParse.Free;
  // check if exist free ID for new node
if newID = true then
  begin
    newID := false;
    for freeID:=1 to 253 do
      begin
       node := FindRootNodeID(inttostr(FreeID),TreeView1);
       if node = nil then break;
      end;
   if CheckBox2.Checked and (FreeID >0) and (node=nil) then
    begin SendNewID:= '255;255;3;1;4;'+inttostr(FreeID)+char($0A);Timer1.Enabled:=true; end;
  end;
end;



procedure TForm1.Button3Click(Sender: TObject);
begin
TreeView1.Items.Clear;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
ValueListEditor1.Strings.Clear;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Timer1.Enabled:=false;
ComPort1.WriteStr(SendNewID);
end;

end.
